/* Behead version 1.2 (C)
    Copyright Oct. 1990 Bill Larkins
    Modified Feb. 1993 for MacBinary format checking
    and to add note as to CIS affiliation */

#include "stdio.h"
#include "stdlib.h"
#include "string.h"

void main(int argc, char *argv[])
{
  FILE *in, *out;
  char ch;
  long int j;
  char str[80];
  char buf[32768];
  int i;

printf("Behead version 1.2 written and Copyright 1990, 1993 by Bill Larkins\n");
printf("         Associate Sysop, CompuServe GAMBPUB Forum\n");
printf("                      CIS ID 71333,1072\n");
printf("\n");
printf("Remove the 128 byte header from a Macintosh MacBinary format file\n");
printf("             for use on IBM and compatible machines.\n");
printf("                Macintosh and IBM are trademarks\n");
printf("\n");
printf("         Use and distribute freely unmodified\n");
printf("\n");
printf("You MUST use an output filename that does not already exist!\n");
printf("\n");
printf("SYNTAX: BEHEAD InFile OutFile, where InFile is the file to be\n");
printf("converted, and OutFile is the desired output filename\n");
printf("or just type BEHEAD, and you will be asked for the filenames.\n");
printf("\n");

 if(argc<3) {
    printf("Input Filename\n");
    gets(str);
        if((in=fopen(str, "rb"))==NULL) {
        printf("cannot open source file\n");
        exit(1);}

do { j = 1; 
printf("Output Filename (must be DIFFERENT than ANY existing filename!)\n");
     gets(str); if((out=fopen(str, "rb"))==NULL) { j =0; }
} while (j>0);

/*Check to see if it's a MacBinary file first! */

j=fread(buf, sizeof(char), 129, in);

if(feof(in)) {
printf("File is shorter than a MacBinary Header! Exiting Program!\n");
fclose(in);
exit(1); };

i = 0;
ch=buf[0];
if(ch == 0) {i++;};
ch=buf[65];
if(ch>64) {i++;};
ch=buf[66];
if(ch>64) {i++;};
ch=buf[67];
if(ch>64) {i++;};
if(i<4) {
printf("Designated input file does not appear to be MacBinary format!\n");
    fclose(in);
    exit(1); };

        if((out=fopen(str, "wb"))==NULL) {
        printf("cannot open destination file\n");
        exit(1);}

}
if(argc>=3){

 if((in=fopen(argv[1], "rb"))==NULL) {
    printf("cannot open source file\n");
    exit(1);
}
 j=1;
 if((out=fopen(argv[2],"rb"))==NULL) {j=0;}
 if(j>0) {printf("          output file already exists!\n");
printf("\n");
printf("You MUST use an output filename that does not already\n");
printf("exist on your disk. Behead will NOT overwrite an existing file!\n");    
          exit(1);}

/*Check to see if it's a MacBinary file first! */

j=fread(buf, sizeof(char), 129, in);

if(feof(in)) {
printf("File is shorter than a MacBinary Header! Exiting Program!\n");
fclose(in);
exit(1);};

i = 0;
ch=buf[0];
if(ch == 0) {i++;};
ch=buf[65];
if(ch>64) {i++;};
ch=buf[66];
if(ch>64) {i++;};
ch=buf[67];
if(ch>64) {i++;};
if(i<4) {
printf("Designated input file does not appear to be MacBinary format!\n");
    fclose(in);
    exit(1); };


 if((out=fopen(argv[2], "wb"))==NULL) {
    printf("cannot open destination file\n");
    exit(1);
}
}  

/*This copies the first file to the second file */

rewind(in);
j = 0;
while(!feof(in))
    {
j=fread(buf, sizeof(char), 128, in);
j = 0;
while(!feof(in))

          {
j=fread(buf, sizeof(char), 32768, in);
fwrite(buf, sizeof(char), j, out);
           }
     } 

  fclose(in);
  fclose(out);

}
